/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_MBOX
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_mbox.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

static int
do_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

static void
close_mbox(struct mf_mbox *mp)
{
	if (mp->mbox) {
		mu_mailbox_close(mp->mbox);
		mu_mailbox_destroy(&mp->mbox);
		mu_list_do(mp->msglist, do_close, NULL);
		mu_list_destroy(&mp->msglist);
		memset(mp, 0, sizeof mp[0]);
	}
}

static void *
alloc_mboxes()
{
	return xcalloc(NMBOXES, sizeof(struct mf_mbox));
}

static void
destroy_mboxes(void *data)
{
	struct mf_mbox *mtab = data;
	struct mf_mbox *p;
	for (p = mtab; p < mtab + NMBOXES; p++) {
		close_mbox(p);
	}
	free(mtab);
}


#line 55

#line 55
static int MBOXTAB_id;
#line 55 "bi_mbox.m4"


static int
find_slot(struct mf_mbox *tab)
{
	int i;
	for (i = 0; i < NMBOXES; i++)
		if (tab[i].mbox == NULL)
			return i;
	return -1;
}
	
/* number mailbox_open(string url) */
void
#line 68
bi_mailbox_open(eval_environ_t env)
#line 68

#line 68 "bi_mbox.m4"
{
#line 68
	
#line 68

#line 68
long __bi_argcnt;
#line 68
char * url;
#line 68
        char * mode;
#line 68
        
#line 68
get_string_arg(env, 1, &url);
#line 68
        get_string_arg(env, 2, &mode);
#line 68
        
#line 68
get_numeric_arg(env, 0, &__bi_argcnt);
#line 68
        adjust_stack(env, __bi_argcnt + 1);
#line 68

#line 68
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 68
		prog_trace(env, "mailbox_open %s %s",url, ((__bi_argcnt > 1) ? mode : ""));;
#line 68

{
	int rc;
	int md;
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
	struct mf_mbox *mp;
	int flags;
	char *p;

	md = find_slot(mbtab);
		if (!(md >= 0))
#line 78
			env_throw_bi(env, mfe_failure, "mailbox_open", _("No more mailboxes available"))
#line 80
;
	debug1(10, "opening mailbox %s", url);
	mp = mbtab + md;

	flags = 0;
	for (p = ((__bi_argcnt > 1) ? mode : "r"); *p; p++) {
		switch (*p) {
		case 'a':
			flags |= MU_STREAM_APPEND;
			break;
			
		case 'r':
			flags |= MU_STREAM_READ;
			break;
			
		case 'w':
			flags |= MU_STREAM_WRITE;
			break;
			
		case '+':
			if (flags & MU_STREAM_READ)
				flags |= MU_STREAM_WRITE;
			else if (flags & MU_STREAM_WRITE)
				/* FIXME: should truncate as well */
				flags |= MU_STREAM_READ|MU_STREAM_CREAT;
			else if (flags & MU_STREAM_APPEND) {
				flags |= MU_STREAM_RDWR | MU_STREAM_CREAT;
			} else
					env_throw_bi(env, mfe_range, "mailbox_open", _("Incorrect mode near `%s'"),p);
#line 111
			break;

		default:
				env_throw_bi(env, mfe_range, "mailbox_open", _("Incorrect mode near `%s'"),p);
#line 117
		}
	}
	
	rc = mu_mailbox_create(&mp->mbox, url);
		if (!(rc == 0))
#line 121
			env_throw_bi(env, mfe_failure, "mailbox_open", _("Cannot create mailbox `%s': %s"),url,mu_strerror(rc))
#line 124
;
	rc = mu_mailbox_open(mp->mbox, flags);
	if (rc) {
		mu_mailbox_destroy(&mp->mbox);
			env_throw_bi(env, mfe_failure, "mailbox_open", _("Cannot open mailbox `%s': %s"),url,mu_strerror(rc));
#line 131
	}
	mu_list_create(&mp->msglist);
	
	
#line 134
do {
#line 134
  push(env, (STKVAL) (md));
#line 134
  return;
#line 134
} while (0);
}
}

/* void mailbox_close(number mbx) */
void
#line 139
bi_mailbox_close(eval_environ_t env)
#line 139

#line 139 "bi_mbox.m4"
{
#line 139
	
#line 139

#line 139

#line 139
long  md;
#line 139
        
#line 139
get_numeric_arg(env, 0, &md);
#line 139
        
#line 139

#line 139
        adjust_stack(env, 1);
#line 139

#line 139
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 139
		prog_trace(env, "mailbox_close %lu",md);;
#line 139

{
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);

		if (!(md >= 0 && md < NMBOXES))
#line 143
			env_throw_bi(env, mfe_range, "mailbox_close", _("Invalid mailbox descriptor"))
#line 145
;
	close_mbox(mbtab + md);
}
}

#line 161

	
/* number mailbox_messages_count(number mbx) */
void
#line 164
bi_mailbox_messages_count(eval_environ_t env)
#line 164

#line 164 "bi_mbox.m4"
{
#line 164
	
#line 164

#line 164

#line 164
long  nmbx;
#line 164
        
#line 164
get_numeric_arg(env, 0, &nmbx);
#line 164
        
#line 164

#line 164
        adjust_stack(env, 1);
#line 164

#line 164
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 164
		prog_trace(env, "mailbox_messages_count %lu",nmbx);;
#line 164

{
	size_t count;
	int rc;
	
#line 168
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 168
	struct mf_mbox *mp;
#line 168
			
#line 168
		if (!(nmbx >= 0 && nmbx < NMBOXES))
#line 168
			env_throw_bi(env, mfe_range, "mailbox_messages_count", _("Invalid mailbox descriptor"))
#line 168
;
#line 168
	mp = mbtab + nmbx;
#line 168
		if (!(mp->mbox))
#line 168
			env_throw_bi(env, mfe_failure, "mailbox_messages_count", _("Mailbox not open"))
#line 168

#line 168
;
	
	rc = mu_mailbox_messages_count(mp->mbox, &count);
		if (!(rc == 0))
#line 171
			env_throw_bi(env, mfe_failure, "mailbox_messages_count", "%s",mu_strerror(rc))
#line 174
;
	
#line 175
do {
#line 175
  push(env, (STKVAL) (count));
#line 175
  return;
#line 175
} while (0);
}
}

/* number mailbox_get_message(number mbx, number msg-no) */
void
#line 180
bi_mailbox_get_message(eval_environ_t env)
#line 180

#line 180 "bi_mbox.m4"
{
#line 180
	
#line 180

#line 180

#line 180
long  nmbx;
#line 180
        long  msgno;
#line 180
        
#line 180
get_numeric_arg(env, 0, &nmbx);
#line 180
        get_numeric_arg(env, 1, &msgno);
#line 180
        
#line 180

#line 180
        adjust_stack(env, 2);
#line 180

#line 180
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 180
		prog_trace(env, "mailbox_get_message %lu %lu",nmbx, msgno);;
#line 180

{
	int rc;
	mu_message_t msg;
	
#line 184
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 184
	struct mf_mbox *mp;
#line 184
			
#line 184
		if (!(nmbx >= 0 && nmbx < NMBOXES))
#line 184
			env_throw_bi(env, mfe_range, "mailbox_get_message", _("Invalid mailbox descriptor"))
#line 184
;
#line 184
	mp = mbtab + nmbx;
#line 184
		if (!(mp->mbox))
#line 184
			env_throw_bi(env, mfe_failure, "mailbox_get_message", _("Mailbox not open"))
#line 184

#line 184
;

	rc = mu_mailbox_get_message(mp->mbox, msgno, &msg);
		if (!(rc == 0))
#line 187
			env_throw_bi(env, mfe_failure, "mailbox_get_message", "%s",mu_strerror(rc))
#line 190
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 192
			env_throw_bi(env, mfe_failure, "mailbox_get_message", _("No more message slots available"))
#line 194
;
	
#line 195
do {
#line 195
  push(env, (STKVAL) (rc));
#line 195
  return;
#line 195
} while (0);
}
}

/* void mailbox_append_message(number mbx, number msg-no) */
void
#line 200
bi_mailbox_append_message(eval_environ_t env)
#line 200

#line 200 "bi_mbox.m4"
{
#line 200
	
#line 200

#line 200

#line 200
long  nmbx;
#line 200
        long  msgno;
#line 200
        
#line 200
get_numeric_arg(env, 0, &nmbx);
#line 200
        get_numeric_arg(env, 1, &msgno);
#line 200
        
#line 200

#line 200
        adjust_stack(env, 2);
#line 200

#line 200
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 200
		prog_trace(env, "mailbox_append_message %lu %lu",nmbx, msgno);;
#line 200

{
	int rc;
	mu_message_t msg;
	
#line 204
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 204
	struct mf_mbox *mp;
#line 204
			
#line 204
		if (!(nmbx >= 0 && nmbx < NMBOXES))
#line 204
			env_throw_bi(env, mfe_range, "mailbox_append_message", _("Invalid mailbox descriptor"))
#line 204
;
#line 204
	mp = mbtab + nmbx;
#line 204
		if (!(mp->mbox))
#line 204
			env_throw_bi(env, mfe_failure, "mailbox_append_message", _("Mailbox not open"))
#line 204

#line 204
;

	msg = bi_message_from_descr(env, msgno);
	rc = mu_mailbox_append_message(mp->mbox, msg);
		if (!(rc == 0))
#line 208
			env_throw_bi(env, mfe_failure, "mailbox_append_message", _("Cannot append message: %s"),mu_strerror(rc))
#line 211
;
}
}


#line 215
void
#line 215
mbox_init_builtin()
#line 215
{
#line 215
	#line 55 "bi_mbox.m4"
MBOXTAB_id = builtin_priv_register(alloc_mboxes, destroy_mboxes);
#line 68 "bi_mbox.m4"
va_builtin_install_ex("mailbox_open", bi_mailbox_open, 0, 0, dtype_number, 2, 1, 0, dtype_string, dtype_string);
#line 139 "bi_mbox.m4"
va_builtin_install_ex("mailbox_close", bi_mailbox_close, 0, 0, dtype_unspecified, 1, 0, 0, dtype_number);
#line 164 "bi_mbox.m4"
va_builtin_install_ex("mailbox_messages_count", bi_mailbox_messages_count, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 180 "bi_mbox.m4"
va_builtin_install_ex("mailbox_get_message", bi_mailbox_get_message, 0, 0, dtype_number, 2, 0, 0, dtype_number, dtype_number);
#line 200 "bi_mbox.m4"
va_builtin_install_ex("mailbox_append_message", bi_mailbox_append_message, 0, 0, dtype_unspecified, 2, 0, 0, dtype_number, dtype_number);

#line 215 "bi_mbox.m4"
		
#line 215
}
#line 589 "../mfd/snarf.m4"

#line 589

